updatedBulletin<template>
  <div>
    <div>
      <add-card-item
        v-if="canAdd"
        :image="'competences.svg'"
        :enable="true"
        @click.native="openModal({})"
      />
    </div>
    <div
      class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 xl:grid-cols-4 gap-8 py-5 w-full"
    >
      <div v-for="competence in competences" :key="competence.id">
        <div>
          <mat-comp-sav-card-item
            @click.native="selectCompetence(competence)"
            :matCompSav="competence"
            :imageName="'competences.svg'"
            @onUpdateClick="openModal(competence)"
            :hideUpdate="!canAdd"
          />
        </div>
      </div>
    </div>
    <modal-competence
      :updatedCompetence="updatedCompetence"
      :forMatiere="matiere"
      :value="modalOpen"
      v-if="modalOpen"
      @closeRequest="modalOpen = false"
    />
  </div>
</template>

<script>
import AddCardItem from "../AddCardItem.vue";
import MatCompSavCardItem from "../MatCompSavCardItem.vue";
import ModalCompetence from "../modals/ModalAddCompetence.vue";
export default {
  components: { MatCompSavCardItem, AddCardItem, ModalCompetence },
  created() {
    this.$emit("titleChanged", this.$attrs.title + this.matiere?.nom);
    /*     this.$store.dispatch("bindCompetences", this.classe);
    this.$store.dispatch("bindSavoirs", this.classe); */
  },
  data() {
    return {
      modalOpen: false,
      updatedCompetence: Object,
      canAdd: this.$attrs.canAdd,
    };
  },
  computed: {
    matiere() {
      return this.$store.getters.getOneMatiere(this.$route.params.matiereid);
    },
    competences() {
      const bulletinid = this.$route.params.bulletinid;
      return bulletinid
        ? this.$store.getters.getCompetencesByBulletin(bulletinid)
        : this.$store.getters.getCompetencesByMatiere(this.matiere);
    },
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
  },
  methods: {
    selectCompetence(competence) {
      const bulletinid = this.$route.params.bulletinid;
      return bulletinid
        ? this.$router.push({
            path: `competences/${competence.id}/evaluations`,
            append: true,
          })
        : this.$router.push({ path: `${competence.id}/savoirs`, append: true });
    },
    openModal(updatedCompetence) {
      this.updatedCompetence = updatedCompetence;
      this.modalOpen = true;
    },
  },
};
</script>

<style>
</style>